import numpy as np
import scipy.stats as ss
    

def calcwaic2(Rs,theta):
    n = len(Rs)
    S = len(theta)
    p_y_theta = np.empty((n, S))
    for i in range(n):
        for s in range(S):
            p_y_theta[i][s] = ss.multinomial(sum(Rs[i]), theta[s][i]).pmf(Rs[i])

    lppd = np.sum(np.log(np.mean(p_y_theta, axis = 1)))  
    pWAIC2 = np.sum(np.var(np.log(p_y_theta), axis = 1, ddof = 1))
    
    return -2 * (lppd - pWAIC2)
    
