
def EstMode(samples, a = 0.05, n_points = 10000):
    """
        Calculatte a MAP estimate from a KDE graph on [Lp, Up]
        Lp and Up are 100*a/2 and 100(1-a/2) percentile points of samples
    """
    import numpy as np
    import scipy.stats as ss
    Lp, Up = np.percentile(samples, [100 * a/2, 100 * (1 - a/2)])  # import numpy as np
    coord = np.linspace(Lp, Up, n_points)  
    est_pdf = ss.gaussian_kde(samples).pdf(coord)  # import scipy.stats as ss
    mode_idx = np.argmax(est_pdf)  
    Mode_Est = coord[mode_idx]        
    return Mode_Est
